Index: LMDZ5/branches/testing/libf/phylmd/iophy.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1864)
@@ -2,8 +2,17 @@
 ! $Header$
 !
-module iophy
-  
-! abd  REAL,private,allocatable,dimension(:),save :: io_lat
-! abd  REAL,private,allocatable,dimension(:),save :: io_lon
+MODULE iophy
+
+  USE phys_output_var_mod
+#ifdef CPP_XIOS
+  USE wxios
+#endif
+
+#ifdef CPP_XIOS
+  USE wxios
+#endif
+
+! abd  REAL,private,allocatable,DIMENSION(:),save :: io_lat
+! abd  REAL,private,allocatable,DIMENSION(:),save :: io_lon
   REAL,ALLOCATABLE,DIMENSION(:),SAVE :: io_lat
   REAL,ALLOCATABLE,DIMENSION(:),SAVE :: io_lon
@@ -14,28 +23,42 @@
 
 !$OMP THREADPRIVATE(itau_iophy)
-  
+
+#ifdef CPP_XIOS
+  INTERFACE histwrite_phy
+    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_phy_old,histwrite3d_phy_old,histwrite2d_xios,histwrite3d_xios
+  END INTERFACE
+#else
   INTERFACE histwrite_phy
     MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy,histwrite2d_phy_old,histwrite3d_phy_old
   END INTERFACE
+#endif
 
   INTERFACE histbeg_phy_all
-    MODULE PROCEDURE histbeg_phy,histbeg_phy_points
+    MODULE PROCEDURE histbeg_phy,histbeg_phyxios,histbeg_phy_points
   END INTERFACE
 
 
-contains
-
-  subroutine init_iophy_new(rlat,rlon)
+CONTAINS
+
+! ug Routine pour définir itau_iophy depuis phys_output_write_mod:
+  SUBROUTINE set_itau_iophy(ito)
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: ito
+      itau_iophy = ito
+  END SUBROUTINE
+
+  SUBROUTINE init_iophy_new(rlat,rlon)
   USE dimphy
   USE mod_phys_lmdz_para
   USE mod_grid_phy_lmdz
   USE ioipsl
-  implicit none
-  include 'dimensions.h'   
-    real,dimension(klon),intent(in) :: rlon
-    real,dimension(klon),intent(in) :: rlat
-
-    REAL,dimension(klon_glo)        :: rlat_glo
-    REAL,dimension(klon_glo)        :: rlon_glo
+
+  IMPLICIT NONE
+  INCLUDE 'dimensions.h'   
+    REAL,DIMENSION(klon),INTENT(IN) :: rlon
+    REAL,DIMENSION(klon),INTENT(IN) :: rlat
+
+    REAL,DIMENSION(klon_glo)        :: rlat_glo
+    REAL,DIMENSION(klon_glo)        :: rlon_glo
     
     INTEGER,DIMENSION(2) :: ddid
@@ -47,4 +70,5 @@
     INTEGER,DIMENSION(2) :: dhe 
     INTEGER :: i    
+    INTEGER :: data_ibegin, data_iend
 
     CALL gather(rlat,rlat_glo)
@@ -65,4 +89,18 @@
     ALLOCATE(io_lon(iim))
     io_lon(:)=rlon_glo(2-1/(iim*jjm):iim+1-1/(iim*jjm))
+!! (I) dtnb   : total number of domains
+!! (I) dnb    : domain number
+!! (I) did(:) : distributed dimensions identifiers
+!!              (up to 5 dimensions are supported)
+!! (I) dsg(:) : total number of points for each dimension
+!! (I) dsl(:) : local number of points for each dimension
+!! (I) dpf(:) : position of first local point for each dimension
+!! (I) dpl(:) : position of last local point for each dimension
+!! (I) dhs(:) : start halo size for each dimension
+!! (I) dhe(:) : end halo size for each dimension
+!! (C) cdnm   : Model domain definition name.
+!!              The names actually supported are :
+!!              "BOX", "APPLE", "ORANGE".
+!!              These names are case insensitive.
 
     ddid=(/ 1,2 /)
@@ -72,25 +110,52 @@
     dpl=(/ iim, jj_end /)
     dhs=(/ ii_begin-1,0 /)
-    if (mpi_rank==mpi_size-1) then
+    IF (mpi_rank==mpi_size-1) THEN
       dhe=(/0,0/)
-    else
+    ELSE
       dhe=(/ iim-ii_end,0 /)  
-    endif
-    
-    call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
+    ENDIF
+
+#ifndef CPP_NO_IOIPSL    
+    CALL flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
                       'APPLE',phys_domain_id)
-
+#endif
+#ifdef CPP_XIOS
+    !Pour els soucis en MPI, réglage du masque:
+    IF (mpi_rank == 0) THEN
+        data_ibegin = 0
+    ELSE 
+        data_ibegin = ii_begin - 1
+    END IF
+
+    IF (mpi_rank == mpi_size-1) THEN
+        data_iend = nbp_lon
+    ELSE
+        data_iend = ii_end + 1
+    END IF
+
+    WRITE(*,*) "TOTO mpirank=",mpi_rank,"iibeg=",ii_begin , "jjbeg=",jj_begin,"jjnb=",jj_nb,"jjend=",jj_end
+
+    !On initialise le domaine xios, maintenant que tout est connu:
+    !SUBROUTINE wxios_domain_param(dom_id, is_sequential, ni, nj, ni_glo, nj_glo,        &
+    !                                ibegin, iend, jbegin, jend,                         &
+    !                                data_ni, data_ibegin,                               &
+    !                                io_lat, io_lon)
+    CALL wxios_domain_param("dom_glo", is_sequential, nbp_lon, jj_nb, nbp_lon, nbp_lat, &
+                            1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
+                            klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
+                            io_lat, io_lon)
+#endif
 !$OMP END MASTER
       
-  end subroutine init_iophy_new
-
-  subroutine init_iophy(lat,lon)
+  END SUBROUTINE init_iophy_new
+
+  SUBROUTINE init_iophy(lat,lon)
   USE dimphy
   USE mod_phys_lmdz_para
-  use ioipsl
-  implicit none
-  include 'dimensions.h'   
-    real,dimension(iim),intent(in) :: lon
-    real,dimension(jjm+1-1/(iim*jjm)),intent(in) :: lat
+  USE ioipsl
+  IMPLICIT NONE
+  INCLUDE 'dimensions.h'   
+    REAL,DIMENSION(iim),INTENT(IN) :: lon
+    REAL,DIMENSION(jjm+1-1/(iim*jjm)),INTENT(IN) :: lat
 
     INTEGER,DIMENSION(2) :: ddid
@@ -120,23 +185,26 @@
     endif
     
+#ifndef CPP_NO_IOIPSL 
     call flio_dom_set(mpi_size,mpi_rank,ddid,dsg,dsl,dpf,dpl,dhs,dhe, &
                       'APPLE',phys_domain_id)
-
+#endif
 !$OMP END MASTER
       
-  end subroutine init_iophy
-  
-  subroutine histbeg_phy(name,itau0,zjulian,dtime,nhori,nid_day)
+  end SUBROUTINE init_iophy
+
+ SUBROUTINE histbeg_phyxios(name,itau0,zjulian,dtime,ffreq,lev,nhori,nid_day)
   USE dimphy
   USE mod_phys_lmdz_para
   use ioipsl
   use write_field
-  implicit none
+  IMPLICIT NONE
   include 'dimensions.h'
     
-    character*(*), intent(IN) :: name
-    integer, intent(in) :: itau0
-    real,intent(in) :: zjulian
-    real,intent(in) :: dtime
+    character*(*), INTENT(IN) :: name
+    integer, INTENT(IN) :: itau0
+    REAL,INTENT(IN) :: zjulian
+    REAL,INTENT(IN) :: dtime
+    character(LEN=*), INTENT(IN) :: ffreq
+    INTEGER,INTENT(IN) :: lev
     integer,intent(out) :: nhori
     integer,intent(out) :: nid_day
@@ -150,9 +218,47 @@
                    1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
     endif
+
+#ifdef CPP_XIOS
+    ! ug OMP en chantier...
+    IF((.NOT. is_using_mpi) .OR. is_mpi_root) THEN
+        ! ug Création du fichier
+        CALL wxios_add_file(name, ffreq, lev)
+    END IF
+#endif
 !$OMP END MASTER
   
-  end subroutine histbeg_phy
-
-  subroutine histbeg_phy_points(rlon,rlat,pim,tabij,ipt,jpt, &
+  END SUBROUTINE histbeg_phyxios
+  
+  SUBROUTINE histbeg_phy(name,itau0,zjulian,dtime,nhori,nid_day)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  use ioipsl
+  use write_field
+  IMPLICIT NONE
+  include 'dimensions.h'
+    
+    character*(*), INTENT(IN) :: name
+    integer, INTENT(IN) :: itau0
+    REAL,INTENT(IN) :: zjulian
+    REAL,INTENT(IN) :: dtime
+    integer,intent(out) :: nhori
+    integer,intent(out) :: nid_day
+
+!$OMP MASTER    
+#ifndef CPP_NO_IOIPSL 
+    if (is_sequential) then
+      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day)
+    else
+      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
+    endif
+#endif
+!$OMP END MASTER
+  
+  END SUBROUTINE histbeg_phy
+
+
+  SUBROUTINE histbeg_phy_points(rlon,rlat,pim,tabij,ipt,jpt, &
              plon,plat,plon_bounds,plat_bounds, &
              nname,itau0,zjulian,dtime,nnhori,nnid_day)
@@ -162,23 +268,23 @@
   use ioipsl
   use write_field
-  implicit none
+  IMPLICIT NONE
   include 'dimensions.h' 
 
-    real,dimension(klon),intent(in) :: rlon
-    real,dimension(klon),intent(in) :: rlat
-    integer, intent(in) :: itau0
-    real,intent(in) :: zjulian
-    real,intent(in) :: dtime
-    integer, intent(in) :: pim
+    REAL,DIMENSION(klon),INTENT(IN) :: rlon
+    REAL,DIMENSION(klon),INTENT(IN) :: rlat
+    integer, INTENT(IN) :: itau0
+    REAL,INTENT(IN) :: zjulian
+    REAL,INTENT(IN) :: dtime
+    integer, INTENT(IN) :: pim
     integer, intent(out) :: nnhori
-    character(len=20), intent(in) :: nname
+    character(len=20), INTENT(IN) :: nname
     INTEGER, intent(out) :: nnid_day
     integer :: i
-    REAL,dimension(klon_glo)        :: rlat_glo
-    REAL,dimension(klon_glo)        :: rlon_glo
-    INTEGER, DIMENSION(pim), intent(in)  :: tabij
-    REAL,dimension(pim), intent(in) :: plat, plon
-    INTEGER,dimension(pim), intent(in) :: ipt, jpt
-    REAL,dimension(pim,2), intent(out) :: plat_bounds, plon_bounds
+    REAL,DIMENSION(klon_glo)        :: rlat_glo
+    REAL,DIMENSION(klon_glo)        :: rlon_glo
+    INTEGER, DIMENSION(pim), INTENT(IN)  :: tabij
+    REAL,DIMENSION(pim), INTENT(IN) :: plat, plon
+    INTEGER,DIMENSION(pim), INTENT(IN) :: ipt, jpt
+    REAL,DIMENSION(pim,2), intent(out) :: plat_bounds, plon_bounds
 
     INTEGER, SAVE :: tabprocbeg, tabprocend
@@ -187,8 +293,8 @@
     INTEGER, PARAMETER :: nip=1
     INTEGER :: npproc
-    REAL, allocatable, dimension(:) :: npplat, npplon
-    REAL, allocatable, dimension(:,:) :: npplat_bounds, npplon_bounds
+    REAL, allocatable, DIMENSION(:) :: npplat, npplon
+    REAL, allocatable, DIMENSION(:,:) :: npplat_bounds, npplon_bounds
     INTEGER, PARAMETER :: jjmp1=jjm+1-1/jjm
-    REAL, dimension(iim,jjmp1) :: zx_lon, zx_lat
+    REAL, DIMENSION(iim,jjmp1) :: zx_lon, zx_lat
 
     CALL gather(rlat,rlat_glo)
@@ -278,7 +384,9 @@
     ENDDO
 !    print*,'iophy is_sequential nname, nnhori, nnid_day=',trim(nname),nnhori,nnid_day
+#ifndef CPP_NO_IOIPSL 
      call histbeg(nname,pim,plon,plon_bounds, & 
                            plat,plat_bounds, &
                            itau0, zjulian, dtime, nnhori, nnid_day)
+#endif
     else
      npproc=0
@@ -317,16 +425,286 @@
       ENDIF
      ENDDO
+#ifndef CPP_NO_IOIPSL 
      call histbeg(nname,npstn,npplon,npplon_bounds, &
                             npplat,npplat_bounds, &
                             itau0,zjulian,dtime,nnhori,nnid_day,phys_domain_id)
+#endif
     endif
 !$OMP END MASTER
 
-  end subroutine histbeg_phy_points
+  end SUBROUTINE histbeg_phy_points
+
+
+  SUBROUTINE histdef2d_old (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    LOGICAL                          :: lpoint
+    INTEGER, DIMENSION(nfiles)       :: flag_var
+    CHARACTER(LEN=20)                 :: nomvar
+    CHARACTER(LEN=*)                 :: titrevar
+    CHARACTER(LEN=*)                 :: unitvar
+
+    REAL zstophym
+
+    IF (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime_moy
+    ENDIF
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(nomvar,flag_var)
+
+    IF(.NOT.lpoint) THEN  
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff),nomvar,titrevar,unitvar, &
+               iim,jj_nb,nhorim(iff), 1,1,1, -99, 32, &
+               type_ecri(iff), zstophym,zoutm(iff))                
+       ENDIF
+    ELSE
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff),nomvar,titrevar,unitvar, &
+               npstn,1,nhorim(iff), 1,1,1, -99, 32, &
+               type_ecri(iff), zstophym,zoutm(iff))                
+       ENDIF
+    ENDIF
+
+    ! Set swaero_diag=true if at least one of the concerned variables are defined 
+    IF (nomvar=='topswad' .OR. nomvar=='topswai' .OR. nomvar=='solswad' .OR. nomvar=='solswai' ) THEN
+       IF  ( flag_var(iff)<=lev_files(iff) ) THEN
+          swaero_diag=.TRUE.
+       END IF
+    END IF
+  END SUBROUTINE histdef2d_old
+
+
+
+  SUBROUTINE histdef3d_old (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+!    INCLUDE "indicesol.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    LOGICAL                          :: lpoint
+    INTEGER, DIMENSION(nfiles)       :: flag_var
+    CHARACTER(LEN=20)                 :: nomvar
+    CHARACTER(LEN=*)                 :: titrevar
+    CHARACTER(LEN=*)                 :: unitvar
+
+    REAL zstophym
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(nomvar,flag_var)
+
+    IF (type_ecri(iff)=='inst(X)'.OR.type_ecri(iff)=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime_moy
+    ENDIF
+
+    IF(.NOT.lpoint) THEN
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), nomvar, titrevar, unitvar, &
+               iim, jj_nb, nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, type_ecri(iff), &
+               zstophym, zoutm(iff))
+       ENDIF
+    ELSE
+       IF ( flag_var(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), nomvar, titrevar, unitvar, &
+               npstn,1,nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, &
+               type_ecri(iff), zstophym,zoutm(iff))
+       ENDIF
+    ENDIF
+  END SUBROUTINE histdef3d_old
+
+
+
+
+
+
+
+
+  SUBROUTINE histdef2d (iff,var)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    TYPE(ctrl_out)                   :: var
+
+    REAL zstophym
+    CHARACTER(LEN=20) :: typeecrit
+
+
+    ! ug On récupère le type écrit de la structure:
+    !       Assez moche, à refaire si meilleure méthode...
+    IF (INDEX(var%type_ecrit(iff), "once") > 0) THEN
+       typeecrit = 'once'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_min") > 0) THEN
+       typeecrit = 't_min(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_max") > 0) THEN
+       typeecrit = 't_max(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "inst") > 0) THEN
+       typeecrit = 'inst(X)'
+    ELSE
+       typeecrit = type_ecri_files(iff)
+    ENDIF
+
+    IF (typeecrit=='inst(X)'.OR.typeecrit=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime_moy
+    ENDIF
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(var%name, var%flag)
+
+    IF(.NOT.clef_stations(iff)) THEN  
+
+#ifdef CPP_XIOS
+        CALL wxios_add_field_to_file(var%name, 2, iff, phys_out_filenames(iff), &
+        var%description, var%unit, var%flag(iff), typeecrit)
+#endif
+#ifndef CPP_NO_IOIPSL 
+
+       IF ( var%flag(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               iim,jj_nb,nhorim(iff), 1,1,1, -99, 32, &
+               typeecrit, zstophym,zoutm(iff))                
+       ENDIF
+    ELSE
+       IF ( var%flag(iff)<=lev_files(iff)) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               npstn,1,nhorim(iff), 1,1,1, -99, 32, &
+               typeecrit, zstophym,zoutm(iff))                
+       ENDIF
+#endif
+    ENDIF
+
+    ! Set swaero_diag=true if at least one of the concerned variables are defined 
+    IF (var%name=='topswad' .OR. var%name=='topswai' .OR. var%name=='solswad' .OR. var%name=='solswai' ) THEN
+       IF  ( var%flag(iff)<=lev_files(iff) ) THEN
+          swaero_diag=.TRUE.
+       END IF
+    END IF
+  END SUBROUTINE histdef2d
+  SUBROUTINE histdef3d (iff,var)
+
+    USE ioipsl
+    USE dimphy
+    USE mod_phys_lmdz_para
+
+    IMPLICIT NONE
+
+    INCLUDE "dimensions.h"
+    INCLUDE "temps.h"
+    INCLUDE "clesphys.h"
+
+    INTEGER                          :: iff
+    TYPE(ctrl_out)                   :: var
+
+    REAL zstophym
+    CHARACTER(LEN=20) :: typeecrit
+
+    ! ug On récupère le type écrit de la structure:
+    !       Assez moche, à refaire si meilleure méthode...
+    IF (INDEX(var%type_ecrit(iff), "once") > 0) THEN
+       typeecrit = 'once'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_min") > 0) THEN
+       typeecrit = 't_min(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "t_max") > 0) THEN
+       typeecrit = 't_max(X)'
+    ELSE IF(INDEX(var%type_ecrit(iff), "inst") > 0) THEN
+       typeecrit = 'inst(X)'
+    ELSE
+       typeecrit = type_ecri_files(iff)
+    ENDIF
+
+
+    ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
+    CALL conf_physoutputs(var%name,var%flag)
+
+    IF (typeecrit=='inst(X)'.OR.typeecrit=='once') THEN
+       zstophym=zoutm(iff)
+    ELSE
+       zstophym=zdtime_moy
+    ENDIF
+
+    IF(.NOT.clef_stations(iff)) THEN
+
+#ifdef CPP_XIOS
+        CALL wxios_add_field_to_file(var%name, 3, iff, phys_out_filenames(iff), &
+        var%description, var%unit, var%flag(iff), typeecrit)
+#endif
+#ifndef CPP_NO_IOIPSL 
+
+       IF ( var%flag(iff)<=lev_files(iff) ) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               iim, jj_nb, nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, typeecrit, &
+               zstophym, zoutm(iff))
+       ENDIF
+    ELSE
+       IF ( var%flag(iff)<=lev_files(iff)) THEN
+          CALL histdef (nid_files(iff), var%name, var%description, var%unit, &
+               npstn,1,nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, &
+               typeecrit, zstophym,zoutm(iff))
+       ENDIF
+#endif
+    ENDIF
+  END SUBROUTINE histdef3d
+
+  SUBROUTINE conf_physoutputs(nam_var,flag_var)
+!!! Lecture des noms et niveau de sortie des variables dans output.def
+    !   en utilisant les routines getin de IOIPSL  
+    use ioipsl
+
+    IMPLICIT NONE
+
+    include 'iniprint.h'
+
+    CHARACTER(LEN=20)                :: nam_var
+    INTEGER, DIMENSION(nfiles)      :: flag_var
+
+    IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
+    CALL getin('flag_'//nam_var,flag_var)
+    CALL getin('name_'//nam_var,nam_var)
+    IF(prt_level>10) WRITE(lunout,*)'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
+
+  END SUBROUTINE conf_physoutputs
+
+
  
   SUBROUTINE histwrite2d_phy_old(nid,lpoint,name,itau,field)
   USE dimphy
   USE mod_phys_lmdz_para
-  USE phys_output_var_mod
   USE ioipsl
   IMPLICIT NONE
@@ -334,18 +712,18 @@
   include 'iniprint.h'
     
-    integer,intent(in) :: nid
-    logical,intent(in) :: lpoint 
-    character*(*), intent(IN) :: name
-    integer, intent(in) :: itau
-    real,dimension(:),intent(in) :: field
-    REAL,dimension(klon_mpi) :: buffer_omp
-    INTEGER, allocatable, dimension(:) :: index2d
+    integer,INTENT(IN) :: nid
+    logical,INTENT(IN) :: lpoint 
+    character*(*), INTENT(IN) :: name
+    integer, INTENT(IN) :: itau
+    REAL,DIMENSION(:),INTENT(IN) :: field
+    REAL,DIMENSION(klon_mpi) :: buffer_omp
+    INTEGER, allocatable, DIMENSION(:) :: index2d
     REAL :: Field2d(iim,jj_nb)
 
     integer :: ip
-    real,allocatable,dimension(:) :: fieldok
-
-
-    IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first dimension not equal to klon',1)
+    REAL,allocatable,DIMENSION(:) :: fieldok
+
+
+    IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first DIMENSION not equal to klon',1)
     
     CALL Gather_omp(field,buffer_omp)    
@@ -387,29 +765,28 @@
 
  
-  end subroutine histwrite2d_phy_old
-
-  subroutine histwrite3d_phy_old(nid,lpoint,name,itau,field)
+  end SUBROUTINE histwrite2d_phy_old
+
+  SUBROUTINE histwrite3d_phy_old(nid,lpoint,name,itau,field)
   USE dimphy
   USE mod_phys_lmdz_para
-  USE phys_output_var_mod
 
   use ioipsl
-  implicit none
+  IMPLICIT NONE
   include 'dimensions.h'
   include 'iniprint.h'
     
-    integer,intent(in) :: nid
-    logical,intent(in) :: lpoint
-    character*(*), intent(IN) :: name
-    integer, intent(in) :: itau
-    real,dimension(:,:),intent(in) :: field  ! --> field(klon,:)
-    REAL,dimension(klon_mpi,size(field,2)) :: buffer_omp
+    integer,INTENT(IN) :: nid
+    logical,INTENT(IN) :: lpoint
+    character*(*), INTENT(IN) :: name
+    integer, INTENT(IN) :: itau
+    REAL,DIMENSION(:,:),INTENT(IN) :: field  ! --> field(klon,:)
+    REAL,DIMENSION(klon_mpi,size(field,2)) :: buffer_omp
     REAL :: Field3d(iim,jj_nb,size(field,2))
     INTEGER :: ip, n, nlev
-    INTEGER, ALLOCATABLE, dimension(:) :: index3d
-    real,allocatable, dimension(:,:) :: fieldok
-
-
-    IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first dimension not equal to klon',1)
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: index3d
+    REAL,allocatable, DIMENSION(:,:) :: fieldok
+
+
+    IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
     nlev=size(field,2)
 
@@ -460,5 +837,7 @@
 !$OMP END MASTER    
 
-  end subroutine histwrite3d_phy_old
+  end SUBROUTINE histwrite3d_phy_old
+
+
 
 
@@ -468,34 +847,30 @@
   USE mod_phys_lmdz_para
   USE ioipsl
-!Pour avoir nfiles, nidfiles tout ça tout ça...
-  USE phys_output_var_mod
   
-  
+
 
 #ifdef CPP_XIOS
-!  USE WXIOS
-#endif
+  USE wxios
+#endif
+
 
   IMPLICIT NONE
-  include 'dimensions.h'
-    
-!    integer,intent(in) :: nid
-!    logical,intent(in) :: lpoint 
-!    character*(*), intent(IN) :: name
-!    integer, intent(in) :: itau
-!    real,dimension(:),intent(in) :: field
-
-      TYPE(ctrl_out), INTENT(IN) :: var
-      REAL, DIMENSION(:), INTENT(IN) :: field
-      INTEGER, INTENT(IN), OPTIONAL :: STD_iff ! ug RUSTINE POUR LES STD LEVS.....
+  INCLUDE 'dimensions.h'
+  INCLUDE 'iniprint.h'
+
+    TYPE(ctrl_out), INTENT(IN) :: var
+    REAL, DIMENSION(:), INTENT(IN) :: field
+    INTEGER, INTENT(IN), OPTIONAL :: STD_iff ! ug RUSTINE POUR LES STD LEVS.....
       
-      INTEGER :: iff, iff_beg, iff_end
+    INTEGER :: iff, iff_beg, iff_end
       
-    REAL,dimension(klon_mpi) :: buffer_omp
-    INTEGER, allocatable, dimension(:) :: index2d
+    REAL,DIMENSION(klon_mpi) :: buffer_omp
+    INTEGER, allocatable, DIMENSION(:) :: index2d
     REAL :: Field2d(iim,jj_nb)
 
     INTEGER :: ip
     REAL, ALLOCATABLE, DIMENSION(:) :: fieldok
+
+    IF (prt_level >= 9) WRITE(lunout,*)'Begin histrwrite2d ',var%name
 
 ! ug RUSTINE POUR LES STD LEVS.....
@@ -508,5 +883,18 @@
       END IF
 
-    IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first dimension not equal to klon',1)
+  ! On regarde si on est dans la phase de définition ou d'écriture:
+  IF(.NOT.vars_defined) THEN
+!$OMP MASTER
+      !Si phase de définition.... on définit
+      DO iff=iff_beg, iff_end
+         IF (clef_files(iff)) THEN
+            CALL histdef2d(iff, var)
+         ENDIF
+      ENDDO
+!$OMP END MASTER
+  ELSE
+
+    !Et sinon on.... écrit
+    IF (SIZE(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first DIMENSION not equal to klon',1)
     
     CALL Gather_omp(field,buffer_omp)    
@@ -521,10 +909,11 @@
                         ALLOCATE(index2d(iim*jj_nb))
                         ALLOCATE(fieldok(iim*jj_nb))
-     
+#ifndef CPP_NO_IOIPSL 
                         CALL histwrite(nid_files(iff),var%name,itau_iophy,Field2d,iim*jj_nb,index2d)
+#endif
 #ifdef CPP_XIOS
-!                        IF (iff .EQ. 1) THEN
-!                              CALL wxios_write_2D(var%name, Field2d)
-!                        ENDIF
+                        IF (iff == iff_beg) THEN
+                              CALL wxios_write_2D(var%name, Field2d)
+                        ENDIF
 #endif
                   ELSE 
@@ -533,6 +922,4 @@
 
                         IF (is_sequential) THEN
-!                            klon_mpi_begin=1
-!                             klon_mpi_end=klon
                               DO ip=1, npstn
                                     fieldok(ip)=buffer_omp(nptabij(ip))
@@ -540,5 +927,5 @@
                              ELSE
                               DO ip=1, npstn
-!                                   print*,'histwrite2d is_sequential npstn ip name nptabij',npstn,ip,name,nptabij(ip)
+                                PRINT*,'histwrite2d is_sequential npstn ip namenptabij',npstn,ip,var%name,nptabij(ip)
                                      IF(nptabij(ip).GE.klon_mpi_begin.AND. &
                                         nptabij(ip).LE.klon_mpi_end) THEN
@@ -547,6 +934,7 @@
                               ENDDO
                        ENDIF
-     
+#ifndef CPP_NO_IOIPSL 
                        CALL histwrite(nid_files(iff),var%name,itau_iophy,fieldok,npstn,index2d)
+#endif
                   ENDIF
                   
@@ -556,16 +944,14 @@
       ENDDO
 !$OMP END MASTER   
-
+  ENDIF ! vars_defined
+  IF (prt_level >= 9) WRITE(lunout,*)'End histrwrite2d ',var%name
   END SUBROUTINE histwrite2d_phy
 
 
 ! ug NOUVELLE VERSION DES WRITE AVEC LA BOUCLE DO RENTREE
-  SUBROUTINE histwrite3d_phy(var, field)
+  SUBROUTINE histwrite3d_phy(var, field, STD_iff)
   USE dimphy
   USE mod_phys_lmdz_para
-
-  use ioipsl
-!Pour avoir nfiles, nidfiles tout ça tout ça...
-  USE phys_output_var_mod  
+  USE ioipsl
   
 
@@ -576,30 +962,45 @@
 
   IMPLICIT NONE
-  include 'dimensions.h'
-    
-!    integer,intent(in) :: nid
-!    logical,intent(in) :: lpoint
-!    character*(*), intent(IN) :: name
-!    integer, intent(in) :: itau
-!    real,dimension(:,:),intent(in) :: field  ! --> field(klon,:)
-
-      TYPE(ctrl_out), INTENT(IN) :: var
-      REAL, DIMENSION(:,:), INTENT(IN) :: field ! --> field(klon,:)
-
+  INCLUDE 'dimensions.h'
+  INCLUDE 'iniprint.h'
+
+    TYPE(ctrl_out), INTENT(IN) :: var
+    REAL, DIMENSION(:,:), INTENT(IN) :: field ! --> field(klon,:)
+    INTEGER, INTENT(IN), OPTIONAL :: STD_iff ! ug RUSTINE POUR LES STD LEVS.....
+      
+    INTEGER :: iff, iff_beg, iff_end
 
     REAL,DIMENSION(klon_mpi,SIZE(field,2)) :: buffer_omp
     REAL :: Field3d(iim,jj_nb,SIZE(field,2))
-    INTEGER :: ip, n, nlev, iff
+    INTEGER :: ip, n, nlev
     INTEGER, ALLOCATABLE, DIMENSION(:) :: index3d
     REAL,ALLOCATABLE, DIMENSION(:,:) :: fieldok
 
-    IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first dimension not equal to klon',1)
-    nlev=size(field,2)
-
-!   print*,'hist3d_phy mpi_rank npstn=',mpi_rank,npstn
-
-!   DO ip=1, npstn
-!    print*,'hist3d_phy mpi_rank nptabij',mpi_rank,nptabij(ip)
-!   ENDDO
+  IF (prt_level >= 9) write(lunout,*)'Begin histrwrite3d ',var%name
+
+! ug RUSTINE POUR LES STD LEVS.....
+      IF (PRESENT(STD_iff)) THEN
+            iff_beg = STD_iff
+            iff_end = STD_iff
+      ELSE
+            iff_beg = 1
+            iff_end = nfiles
+      END IF
+
+  ! On regarde si on est dans la phase de définition ou d'écriture:
+  IF(.NOT.vars_defined) THEN
+      !Si phase de définition.... on définit
+!$OMP MASTER
+      DO iff=iff_beg, iff_end
+        IF (clef_files(iff)) THEN
+          CALL histdef3d(iff, var)
+        ENDIF
+      ENDDO
+!$OMP END MASTER
+  ELSE
+    !Et sinon on.... écrit
+    IF (SIZE(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
+    nlev=SIZE(field,2)
+
 
     CALL Gather_omp(field,buffer_omp)
@@ -609,14 +1010,18 @@
 
 ! BOUCLE SUR LES FICHIERS
-      DO iff=1, nfiles
+     DO iff=iff_beg, iff_end
             IF (var%flag(iff) <= lev_files(iff) .AND. clef_files(iff)) THEN
                 IF (.NOT.clef_stations(iff)) THEN
                         ALLOCATE(index3d(iim*jj_nb*nlev))
                         ALLOCATE(fieldok(iim*jj_nb,nlev))
+
+#ifndef CPP_NO_IOIPSL 
                         CALL histwrite(nid_files(iff),var%name,itau_iophy,Field3d,iim*jj_nb*nlev,index3d)
+#endif
+
 #ifdef CPP_XIOS
-!                        IF (iff .EQ. 1) THEN
-!                              CALL wxios_write_3D(var%name, Field3d(:,:,1:klev))
-!                        ENDIF
+                        IF (iff == 1) THEN
+                              CALL wxios_write_3D(var%name, Field3d(:,:,1:klev))
+                        ENDIF
 #endif
                         
@@ -627,6 +1032,4 @@
 
                         IF (is_sequential) THEN
-            !                  klon_mpi_begin=1
-            !                  klon_mpi_end=klon
                               DO n=1, nlev
                                     DO ip=1, npstn
@@ -644,5 +1047,7 @@
                               ENDDO
                         ENDIF
+#ifndef CPP_NO_IOIPSL 
                         CALL histwrite(nid_files(iff),var%name,itau_iophy,fieldok,npstn*nlev,index3d)
+#endif
                   ENDIF 
                   deallocate(index3d)
